// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GetMessageLocallyRequest represents TL type `getMessageLocally#dc062b6c`.
type GetMessageLocallyRequest struct {
	// Identifier of the chat the message belongs to
	ChatID int64
	// Identifier of the message to get
	MessageID int64
}

// GetMessageLocallyRequestTypeID is TL type id of GetMessageLocallyRequest.
const GetMessageLocallyRequestTypeID = 0xdc062b6c

// Ensuring interfaces in compile-time for GetMessageLocallyRequest.
var (
	_ bin.Encoder     = &GetMessageLocallyRequest{}
	_ bin.Decoder     = &GetMessageLocallyRequest{}
	_ bin.BareEncoder = &GetMessageLocallyRequest{}
	_ bin.BareDecoder = &GetMessageLocallyRequest{}
)

func (g *GetMessageLocallyRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.ChatID == 0) {
		return false
	}
	if !(g.MessageID == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GetMessageLocallyRequest) String() string {
	if g == nil {
		return "GetMessageLocallyRequest(nil)"
	}
	type Alias GetMessageLocallyRequest
	return fmt.Sprintf("GetMessageLocallyRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GetMessageLocallyRequest) TypeID() uint32 {
	return GetMessageLocallyRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*GetMessageLocallyRequest) TypeName() string {
	return "getMessageLocally"
}

// TypeInfo returns info about TL type.
func (g *GetMessageLocallyRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "getMessageLocally",
		ID:   GetMessageLocallyRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ChatID",
			SchemaName: "chat_id",
		},
		{
			Name:       "MessageID",
			SchemaName: "message_id",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GetMessageLocallyRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getMessageLocally#dc062b6c as nil")
	}
	b.PutID(GetMessageLocallyRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GetMessageLocallyRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getMessageLocally#dc062b6c as nil")
	}
	b.PutInt53(g.ChatID)
	b.PutInt53(g.MessageID)
	return nil
}

// Decode implements bin.Decoder.
func (g *GetMessageLocallyRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getMessageLocally#dc062b6c to nil")
	}
	if err := b.ConsumeID(GetMessageLocallyRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode getMessageLocally#dc062b6c: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GetMessageLocallyRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getMessageLocally#dc062b6c to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode getMessageLocally#dc062b6c: field chat_id: %w", err)
		}
		g.ChatID = value
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode getMessageLocally#dc062b6c: field message_id: %w", err)
		}
		g.MessageID = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GetMessageLocallyRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode getMessageLocally#dc062b6c as nil")
	}
	b.ObjStart()
	b.PutID("getMessageLocally")
	b.Comma()
	b.FieldStart("chat_id")
	b.PutInt53(g.ChatID)
	b.Comma()
	b.FieldStart("message_id")
	b.PutInt53(g.MessageID)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GetMessageLocallyRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode getMessageLocally#dc062b6c to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("getMessageLocally"); err != nil {
				return fmt.Errorf("unable to decode getMessageLocally#dc062b6c: %w", err)
			}
		case "chat_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode getMessageLocally#dc062b6c: field chat_id: %w", err)
			}
			g.ChatID = value
		case "message_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode getMessageLocally#dc062b6c: field message_id: %w", err)
			}
			g.MessageID = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetChatID returns value of ChatID field.
func (g *GetMessageLocallyRequest) GetChatID() (value int64) {
	if g == nil {
		return
	}
	return g.ChatID
}

// GetMessageID returns value of MessageID field.
func (g *GetMessageLocallyRequest) GetMessageID() (value int64) {
	if g == nil {
		return
	}
	return g.MessageID
}

// GetMessageLocally invokes method getMessageLocally#dc062b6c returning error if any.
func (c *Client) GetMessageLocally(ctx context.Context, request *GetMessageLocallyRequest) (*Message, error) {
	var result Message

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
